<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>JR3.50</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.4/css/all.min.css">
</head>

<body>
    <div class="container text-center">
        <h2>Cập nhật thông tin học viên</h2>
        <div class="d-flex justify-content-center">
            <div class="w-75">
                <div class="row form-group text-left">
                    <div class="col-3">
                        <label class="mt-2" for="inp-name">Họ và tên <span class="text-danger">*</span></label>
                    </div>
                    <div class="col-9">
                        <input id="inp-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row form-group text-left">
                    <div class="col-3">
                        <label class="mt-2" for="inp-birthday">Ngày sinh <span class="text-danger">*</span></label>
                    </div>
                    <div class="col-9">
                        <input id="inp-birthday" class="form-control" type="text">
                    </div>
                </div>
                <div class="row form-group text-left">
                    <div class="col-3">
                        <label class="mt-2" for="inp-email">Email <span class="text-danger">*</span></label>
                    </div>
                    <div class="col-9">
                        <input id="inp-email" class="form-control" type="text">
                    </div>
                </div>
                <div class="row form-group text-left">
                    <div class="col-3">
                        <label class="mt-2" for="inp-phone">Phone <span class="text-danger">*</span></label>
                    </div>
                    <div class="col-9">
                        <input id="inp-phone" class="form-control" type="text">
                    </div>
                </div>
            </div>
        </div>
        <div class="d-flex justify-content-center">
            <button class="btn btn-secondary come-back"><i class="fa fa-chevron-left"></i> Quay lại</button>
            <button class="btn btn-success ml-2 btn-save"><i class="fa fa-save"></i> Lưu</button>
        </div>
    </div>

</body>

<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://devcamp-student.herokuapp.com/users/";
    var gID = "";
    var gDataStudent = {};

    $(document).ready(function(){
        // Lấy Id của học sinh cần chỉnh sửa thông tin
        getIdStudent()

        // call API để chỉnh sửa thông tin học viên cần chỉnh
        callApiGetStudent()

        // load thông tin học sinh vào form
        loadDataToForm();

        // Hàm ấn nút quay lại 
        $('.come-back').on('click',function(){
            onBtnBackClick();
        })

        // Hàm ấn nút Lưu
        $('.btn-save').on('click',function(){
            onBtnSaveClick();
        })
    })
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    function getIdStudent(){
        "use strict";
        $.urlParam = function (name) {
            var results = new RegExp('[\?&]' + name + '=([^&#]*)')
                .exec(window.location.search);
            return (results !== null) ? results[1] || 0 : false;
        }
        gID = $.urlParam('id')
    }

    // Hàm xử lý sự kiện khi ấn nút Lưu
    function onBtnSaveClick(){
        "use strict";
        var vData = {
            name:"",
            birthday:"",
            email:"",
            phone:"",
        }

        //B1: Thu thập dữ liệu
        getDataStudent(vData);
        //B2: Kiểm tra dữ liệu
        var vCheck = validateData(vData);
        if(vCheck){
            //B3:Gọi Api để sửa dữ liệu
            callApiEditStudent(vData);
        }
    }
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnBackClick(){
        "use strict";
        window.location.href = "JR3.S50.html";
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    // Hàm call Api xử lý thông tin học viên cần chỉnh sửa
    function callApiGetStudent(){
        "use strict";
        $.ajax({
            url:gBASE_URL + gID,
            type:"GET",
            async:false,
            success:function(res){
                console.log(res);
                gDataStudent = res;
            },
            error:function(error){
                console.log(error.status);
            }
        })
    }

    //Hàm xử lý load thông tin vào form
    function loadDataToForm(){
        "use strict";
        $('#inp-name').val(gDataStudent.name);
        $('#inp-birthday').val(gDataStudent.birthday);
        $('#inp-email').val(gDataStudent.email);
        $('#inp-phone').val(gDataStudent.phone);
    }

    // Hàm thu thập dữ liệu
    function getDataStudent(paramData){
        "use strict";
        paramData.name = $('#inp-name').val().trim();
        paramData.birthday = $('#inp-birthday').val().trim();
        paramData.email = $('#inp-email').val().trim();
        paramData.phone = $('#inp-phone').val().trim();
    }

    // Kiểm tra dữ liệu
    function validateData(paramData){
        "use strict";
        if (paramData.name == "") {
            alert('Vui lòng nhập tên!');
            return false
        }
        if (paramData.birthday == "") {
            alert('Vui lòng nhập ngày sinh!');
            return false;
        }
        if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(paramData.email)) {
        }
        else {
            alert("Vui lòng điền email đúng(gồm các ký tự @)!");
            return false;
        }
        if (isNaN(paramData.phone)) {
            alert('Vui lòng nhập số điện thoại là số!');
            return false;
        }
        if(paramData.phone == ""){
            alert("Vui lòng nhập số điện thoại là sô!");
            return false;
        }
        return true;
    }

    // Hàm Call Api để Edit học sinh
    function callApiEditStudent(paramData){
        "use strict";
        $.ajax({
            url:gBASE_URL + gID,
            type:"PUT",
            contentType: "application/json",
            data:JSON.stringify(paramData),
            success:function(res){
                console.log(res);
                alert("Sửa mới thông tin thành công!");
                // Quay lại trang
                window.location.href = "JR3.S50.html"
            },
            error:function(error){
                alert("Sửa mới thông tin thất bại!");
                console.log(error.status);
            }
        })
    }
</script>

</html>